<html>
<head>
<title>OgreResourceGroupManager.h Source File - OGRE Documentation</title> <meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1"> 
<link type="text/css" rel="stylesheet" href="doxygen.css">
<link type="text/css" rel="stylesheet" href="tabs.css">
</head>

<body>
<!-- Generated by Doxygen 1.7.6.1 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.html"><span>Main&#160;Page</span></a></li>
      <li><a href="pages.html"><span>Related&#160;Pages</span></a></li>
      <li><a href="modules.html"><span>Modules</span></a></li>
      <li><a href="namespaces.html"><span>Namespaces</span></a></li>
      <li><a href="annotated.html"><span>Classes</span></a></li>
      <li class="current"><a href="files.html"><span>Files</span></a></li>
      <li><a href="dirs.html"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.html"><span>File&#160;List</span></a></li>
      <li><a href="globals.html"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_aff4b7fb8d70b825eb8a2d7b3cbd2684.html">OgreMain</a>      </li>
      <li class="navelem"><a class="el" href="dir_5049b8c488e02232e72cb8867fab4a28.html">include</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">OgreResourceGroupManager.h</div>  </div>
</div><!--header-->
<div class="contents">
<a href="OgreResourceGroupManager_8h.html">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">/*</span>
<a name="l00002"></a>00002 <span class="comment">-----------------------------------------------------------------------------</span>
<a name="l00003"></a>00003 <span class="comment">This source file is part of OGRE</span>
<a name="l00004"></a>00004 <span class="comment">(Object-oriented Graphics Rendering Engine)</span>
<a name="l00005"></a>00005 <span class="comment">For the latest info, see http://www.ogre3d.org/</span>
<a name="l00006"></a>00006 <span class="comment"></span>
<a name="l00007"></a>00007 <span class="comment">Copyright (c) 2000-2012 Torus Knot Software Ltd</span>
<a name="l00008"></a>00008 <span class="comment"></span>
<a name="l00009"></a>00009 <span class="comment">Permission is hereby granted, free of charge, to any person obtaining a copy</span>
<a name="l00010"></a>00010 <span class="comment">of this software and associated documentation files (the &quot;Software&quot;), to deal</span>
<a name="l00011"></a>00011 <span class="comment">in the Software without restriction, including without limitation the rights</span>
<a name="l00012"></a>00012 <span class="comment">to use, copy, modify, merge, publish, distribute, sublicense, and/or sell</span>
<a name="l00013"></a>00013 <span class="comment">copies of the Software, and to permit persons to whom the Software is</span>
<a name="l00014"></a>00014 <span class="comment">furnished to do so, subject to the following conditions:</span>
<a name="l00015"></a>00015 <span class="comment"></span>
<a name="l00016"></a>00016 <span class="comment">The above copyright notice and this permission notice shall be included in</span>
<a name="l00017"></a>00017 <span class="comment">all copies or substantial portions of the Software.</span>
<a name="l00018"></a>00018 <span class="comment"></span>
<a name="l00019"></a>00019 <span class="comment">THE SOFTWARE IS PROVIDED &quot;AS IS&quot;, WITHOUT WARRANTY OF ANY KIND, EXPRESS OR</span>
<a name="l00020"></a>00020 <span class="comment">IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,</span>
<a name="l00021"></a>00021 <span class="comment">FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE</span>
<a name="l00022"></a>00022 <span class="comment">AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER</span>
<a name="l00023"></a>00023 <span class="comment">LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,</span>
<a name="l00024"></a>00024 <span class="comment">OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN</span>
<a name="l00025"></a>00025 <span class="comment">THE SOFTWARE.</span>
<a name="l00026"></a>00026 <span class="comment">-----------------------------------------------------------------------------</span>
<a name="l00027"></a>00027 <span class="comment">*/</span>
<a name="l00028"></a>00028 <span class="preprocessor">#ifndef _ResourceGroupManager_H__</span>
<a name="l00029"></a>00029 <span class="preprocessor"></span><span class="preprocessor">#define _ResourceGroupManager_H__</span>
<a name="l00030"></a>00030 <span class="preprocessor"></span>
<a name="l00031"></a>00031 <span class="preprocessor">#include &quot;<a class="code" href="OgrePrerequisites_8h.html">OgrePrerequisites.h</a>&quot;</span>
<a name="l00032"></a>00032 <span class="preprocessor">#include &quot;<a class="code" href="OgreSingleton_8h.html">OgreSingleton.h</a>&quot;</span>
<a name="l00033"></a>00033 <span class="preprocessor">#include &quot;<a class="code" href="OgreCommon_8h.html">OgreCommon.h</a>&quot;</span>
<a name="l00034"></a>00034 <span class="preprocessor">#include &quot;<a class="code" href="OgreDataStream_8h.html">OgreDataStream.h</a>&quot;</span>
<a name="l00035"></a>00035 <span class="preprocessor">#include &quot;<a class="code" href="OgreResource_8h.html">OgreResource.h</a>&quot;</span>
<a name="l00036"></a>00036 <span class="preprocessor">#include &quot;<a class="code" href="OgreArchive_8h.html">OgreArchive.h</a>&quot;</span>
<a name="l00037"></a>00037 <span class="preprocessor">#include &quot;<a class="code" href="OgreIteratorWrappers_8h.html">OgreIteratorWrappers.h</a>&quot;</span>
<a name="l00038"></a>00038 <span class="preprocessor">#include &lt;ctime&gt;</span>
<a name="l00039"></a>00039 
<a name="l00040"></a>00040 <span class="comment">// If X11/Xlib.h gets included before this header (for example it happens when</span>
<a name="l00041"></a>00041 <span class="comment">// including wxWidgets and FLTK), Status is defined as an int which we don&#39;t</span>
<a name="l00042"></a>00042 <span class="comment">// want as we have an enum named Status.</span>
<a name="l00043"></a>00043 <span class="preprocessor">#ifdef Status</span>
<a name="l00044"></a>00044 <span class="preprocessor"></span><span class="preprocessor">#undef Status</span>
<a name="l00045"></a>00045 <span class="preprocessor"></span><span class="preprocessor">#endif</span>
<a name="l00046"></a>00046 <span class="preprocessor"></span>
<a name="l00047"></a>00047 <span class="keyword">namespace </span>Ogre {
<a name="l00048"></a>00048 
<a name="l00085"></a><a class="code" href="classOgre_1_1ResourceGroupListener.html">00085</a>     <span class="keyword">class </span><a class="code" href="OgrePlatform_8h.html#a20566b1253bae200372ed9162489a663">_OgreExport</a> <a class="code" href="classOgre_1_1ResourceGroupListener.html" title="This abstract class defines an interface which is called back during resource group loading to indica...">ResourceGroupListener</a>
<a name="l00086"></a>00086     {
<a name="l00087"></a>00087     <span class="keyword">public</span>:
<a name="l00088"></a><a class="code" href="classOgre_1_1ResourceGroupListener.html#af53d0887dbc49e858f590a7ae4fb0a31">00088</a>         <span class="keyword">virtual</span> <a class="code" href="classOgre_1_1ResourceGroupListener.html#af53d0887dbc49e858f590a7ae4fb0a31">~ResourceGroupListener</a>() {}
<a name="l00089"></a>00089 
<a name="l00099"></a>00099         <span class="keyword">virtual</span> <span class="keywordtype">void</span> resourceGroupScriptingStarted(<span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; groupName, <span class="keywordtype">size_t</span> scriptCount) = 0;
<a name="l00107"></a>00107         <span class="keyword">virtual</span> <span class="keywordtype">void</span> scriptParseStarted(<span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; scriptName, <span class="keywordtype">bool</span>&amp; skipThisScript) = 0;
<a name="l00108"></a>00108 
<a name="l00111"></a>00111         <span class="keyword">virtual</span> <span class="keywordtype">void</span> scriptParseEnded(<span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; scriptName, <span class="keywordtype">bool</span> skipped) = 0;
<a name="l00113"></a>00113         <span class="keyword">virtual</span> <span class="keywordtype">void</span> resourceGroupScriptingEnded(<span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; groupName) = 0;
<a name="l00114"></a>00114 
<a name="l00120"></a><a class="code" href="classOgre_1_1ResourceGroupListener.html#a6373c4d2c4be1754ba88075130090a4e">00120</a>         <span class="keyword">virtual</span> <span class="keywordtype">void</span> resourceGroupPrepareStarted(<span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; groupName, <span class="keywordtype">size_t</span> resourceCount)
<a name="l00121"></a>00121                 { (void)groupName; (void)resourceCount; }
<a name="l00122"></a>00122 
<a name="l00126"></a><a class="code" href="classOgre_1_1ResourceGroupListener.html#a2127468fe0a61339f4a9e0490d8d6073">00126</a>         <span class="keyword">virtual</span> <span class="keywordtype">void</span> resourcePrepareStarted(<span class="keyword">const</span> <a class="code" href="classOgre_1_1SharedPtr.html">ResourcePtr</a>&amp; resource)
<a name="l00127"></a>00127                 { (void)resource; }
<a name="l00128"></a>00128 
<a name="l00131"></a><a class="code" href="classOgre_1_1ResourceGroupListener.html#ae00f90c7c6f719f3eccc6cf4f5088ed2">00131</a>         <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classOgre_1_1ResourceGroupListener.html#ae00f90c7c6f719f3eccc6cf4f5088ed2" title="This event is fired when the resource has been prepared.">resourcePrepareEnded</a>(<span class="keywordtype">void</span>) {}
<a name="l00137"></a><a class="code" href="classOgre_1_1ResourceGroupListener.html#a8de1d0b6cda474136c540f90d5b08fc9">00137</a>         <span class="keyword">virtual</span> <span class="keywordtype">void</span> worldGeometryPrepareStageStarted(<span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; description)
<a name="l00138"></a>00138         { (void)description; }
<a name="l00139"></a>00139 
<a name="l00145"></a><a class="code" href="classOgre_1_1ResourceGroupListener.html#aa9e0e3419c71a37ba2d6b2530a58716b">00145</a>         <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classOgre_1_1ResourceGroupListener.html#aa9e0e3419c71a37ba2d6b2530a58716b" title="This event is fired when a stage of preparing linked world geometry has been completed.">worldGeometryPrepareStageEnded</a>(<span class="keywordtype">void</span>) {}
<a name="l00147"></a><a class="code" href="classOgre_1_1ResourceGroupListener.html#ae64fcd5c58ef20b4d030762b11662415">00147</a>         <span class="keyword">virtual</span> <span class="keywordtype">void</span> resourceGroupPrepareEnded(<span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; groupName)
<a name="l00148"></a>00148         { (void)groupName; }
<a name="l00149"></a>00149 
<a name="l00155"></a>00155         <span class="keyword">virtual</span> <span class="keywordtype">void</span> resourceGroupLoadStarted(<span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; groupName, <span class="keywordtype">size_t</span> resourceCount) = 0;
<a name="l00159"></a>00159         <span class="keyword">virtual</span> <span class="keywordtype">void</span> resourceLoadStarted(<span class="keyword">const</span> <a class="code" href="classOgre_1_1SharedPtr.html">ResourcePtr</a>&amp; resource) = 0;
<a name="l00162"></a>00162         <span class="keyword">virtual</span> <span class="keywordtype">void</span> resourceLoadEnded(<span class="keywordtype">void</span>) = 0;
<a name="l00168"></a>00168         <span class="keyword">virtual</span> <span class="keywordtype">void</span> worldGeometryStageStarted(<span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; description) = 0;
<a name="l00174"></a>00174         <span class="keyword">virtual</span> <span class="keywordtype">void</span> worldGeometryStageEnded(<span class="keywordtype">void</span>) = 0;
<a name="l00176"></a>00176         <span class="keyword">virtual</span> <span class="keywordtype">void</span> resourceGroupLoadEnded(<span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; groupName) = 0;
<a name="l00177"></a>00177     };
<a name="l00178"></a>00178 
<a name="l00184"></a><a class="code" href="classOgre_1_1ResourceLoadingListener.html">00184</a>     <span class="keyword">class </span><a class="code" href="classOgre_1_1ResourceLoadingListener.html">ResourceLoadingListener</a>
<a name="l00185"></a>00185     {
<a name="l00186"></a>00186     <span class="keyword">public</span>:
<a name="l00187"></a><a class="code" href="classOgre_1_1ResourceLoadingListener.html#ab4624f7ad2c8c23ce489f6733c44aaa7">00187</a>         <span class="keyword">virtual</span> <a class="code" href="classOgre_1_1ResourceLoadingListener.html#ab4624f7ad2c8c23ce489f6733c44aaa7">~ResourceLoadingListener</a>() {}
<a name="l00188"></a>00188 
<a name="l00190"></a>00190         <span class="keyword">virtual</span> <a class="code" href="classOgre_1_1SharedPtr.html">DataStreamPtr</a> <a class="code" href="classOgre_1_1ResourceLoadingListener.html#a7d80ca210ccc9243f737f5f1f3f48f67" title="This event is called when a resource beings loading.">resourceLoading</a>(<span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> &amp;name, <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> &amp;group, <a class="code" href="classOgre_1_1Resource.html" title="Abstract class representing a loadable resource (e.g.">Resource</a> *resource) = 0;
<a name="l00191"></a>00191 
<a name="l00197"></a>00197         <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classOgre_1_1ResourceLoadingListener.html#af1856e826dd312b6ae86a83b57f28cc6" title="This event is called when a resource stream has been opened, but not processed yet.">resourceStreamOpened</a>(<span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> &amp;name, <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> &amp;group, <a class="code" href="classOgre_1_1Resource.html" title="Abstract class representing a loadable resource (e.g.">Resource</a> *resource, <a class="code" href="classOgre_1_1SharedPtr.html">DataStreamPtr</a>&amp; dataStream) = 0;
<a name="l00198"></a>00198 
<a name="l00201"></a>00201         <span class="keyword">virtual</span> <span class="keywordtype">bool</span> <a class="code" href="classOgre_1_1ResourceLoadingListener.html#a62badbb7992a529cdfa35f23b9401141" title="This event is called when a resource collides with another existing one in a resource manager...">resourceCollision</a>(<a class="code" href="classOgre_1_1Resource.html" title="Abstract class representing a loadable resource (e.g.">Resource</a> *resource, <a class="code" href="classOgre_1_1ResourceManager.html" title="Defines a generic resource handler.">ResourceManager</a> *resourceManager) = 0;
<a name="l00202"></a>00202     };
<a name="l00203"></a>00203 
<a name="l00252"></a><a class="code" href="classOgre_1_1ResourceGroupManager.html">00252</a>     <span class="keyword">class </span><a class="code" href="OgrePlatform_8h.html#a20566b1253bae200372ed9162489a663">_OgreExport</a> <a class="code" href="classOgre_1_1ResourceGroupManager.html" title="This singleton class manages the list of resource groups, and notifying the various resource managers...">ResourceGroupManager</a> : <span class="keyword">public</span> <a class="code" href="classOgre_1_1Singleton.html" title="Template class for creating single-instance global classes.">Singleton</a>&lt;ResourceGroupManager&gt;, <span class="keyword">public</span> <a class="code" href="classOgre_1_1AllocatedObject.html" title="Superclass for all objects that wish to use custom memory allocators when their new / delete operator...">ResourceAlloc</a>
<a name="l00253"></a>00253     {
<a name="l00254"></a>00254     <span class="keyword">public</span>:
<a name="l00255"></a>00255         <a class="code" href="OgrePrerequisites_8h.html#a18a523fad1f9e10324e1742865f562b7">OGRE_AUTO_MUTEX</a> <span class="comment">// public to allow external locking</span>
<a name="l00257"></a><a class="code" href="classOgre_1_1ResourceGroupManager.html#a62561ccf5ff323942a9a4fab94bee7e3">00257</a> <span class="comment"></span>        <span class="keyword">static</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> <a class="code" href="classOgre_1_1ResourceGroupManager.html#a62561ccf5ff323942a9a4fab94bee7e3" title="Default resource group name.">DEFAULT_RESOURCE_GROUP_NAME</a>;
<a name="l00259"></a><a class="code" href="classOgre_1_1ResourceGroupManager.html#a41cf771aba39d52af949d5295e7e18e3">00259</a>         <span class="keyword">static</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> <a class="code" href="classOgre_1_1ResourceGroupManager.html#a41cf771aba39d52af949d5295e7e18e3" title="Internal resource group name (should be used by OGRE internal only)">INTERNAL_RESOURCE_GROUP_NAME</a>;
<a name="l00261"></a><a class="code" href="classOgre_1_1ResourceGroupManager.html#a70da3137e703c147b98fbfbbebfbf023">00261</a>         <span class="keyword">static</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> <a class="code" href="classOgre_1_1ResourceGroupManager.html#a70da3137e703c147b98fbfbbebfbf023" title="Special resource group name which causes resource group to be automatically determined based on searc...">AUTODETECT_RESOURCE_GROUP_NAME</a>;
<a name="l00263"></a><a class="code" href="classOgre_1_1ResourceGroupManager.html#a2f859bb7ae7ea232379d238c8fdfd142">00263</a>         <span class="keyword">static</span> <span class="keywordtype">size_t</span> <a class="code" href="classOgre_1_1ResourceGroupManager.html#a2f859bb7ae7ea232379d238c8fdfd142" title="The number of reference counts held per resource by the resource system.">RESOURCE_SYSTEM_NUM_REFERENCE_COUNTS</a>;
<a name="l00265"></a><a class="code" href="structOgre_1_1ResourceGroupManager_1_1ResourceDeclaration.html">00265</a>         <span class="keyword">struct </span><a class="code" href="structOgre_1_1ResourceGroupManager_1_1ResourceDeclaration.html" title="Nested struct defining a resource declaration.">ResourceDeclaration</a>
<a name="l00266"></a>00266         {
<a name="l00267"></a><a class="code" href="structOgre_1_1ResourceGroupManager_1_1ResourceDeclaration.html#ae2e29633ab1798c3f99151618b963d73">00267</a>             <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> <a class="code" href="structOgre_1_1ResourceGroupManager_1_1ResourceDeclaration.html#ae2e29633ab1798c3f99151618b963d73">resourceName</a>;
<a name="l00268"></a><a class="code" href="structOgre_1_1ResourceGroupManager_1_1ResourceDeclaration.html#aae401b65d364881e950953a3a15e2977">00268</a>             <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> <a class="code" href="structOgre_1_1ResourceGroupManager_1_1ResourceDeclaration.html#aae401b65d364881e950953a3a15e2977">resourceType</a>;
<a name="l00269"></a><a class="code" href="structOgre_1_1ResourceGroupManager_1_1ResourceDeclaration.html#a9322aeaf8777145d9fb4d71d30d133f3">00269</a>             <a class="code" href="classOgre_1_1ManualResourceLoader.html" title="Interface describing a manual resource loader.">ManualResourceLoader</a>* <a class="code" href="structOgre_1_1ResourceGroupManager_1_1ResourceDeclaration.html#a9322aeaf8777145d9fb4d71d30d133f3">loader</a>;
<a name="l00270"></a><a class="code" href="structOgre_1_1ResourceGroupManager_1_1ResourceDeclaration.html#af4c80eff88505c4aa6a24fedb7411c56">00270</a>             <a class="code" href="group__General.html#gadccb207c184efc0a6fb2a00ab6320d19" title="Name / value parameter pair (first = name, second = value)">NameValuePairList</a> <a class="code" href="structOgre_1_1ResourceGroupManager_1_1ResourceDeclaration.html#af4c80eff88505c4aa6a24fedb7411c56">parameters</a>;
<a name="l00271"></a>00271         };
<a name="l00273"></a><a class="code" href="classOgre_1_1ResourceGroupManager.html#a995494b3213135be428eef21990744e5">00273</a>         <span class="keyword">typedef</span> <a class="code" href="structOgre_1_1list.html">list&lt;ResourceDeclaration&gt;::type</a> <a class="code" href="classOgre_1_1ResourceGroupManager.html#a995494b3213135be428eef21990744e5" title="List of resource declarations.">ResourceDeclarationList</a>;
<a name="l00274"></a><a class="code" href="classOgre_1_1ResourceGroupManager.html#af93b96bb29c7d5b2ecc0d37bc82841d4">00274</a>         <span class="keyword">typedef</span> <a class="code" href="structOgre_1_1map.html">map&lt;String, ResourceManager*&gt;::type</a> <a class="code" href="classOgre_1_1ResourceGroupManager.html#af93b96bb29c7d5b2ecc0d37bc82841d4">ResourceManagerMap</a>;
<a name="l00275"></a><a class="code" href="classOgre_1_1ResourceGroupManager.html#af875db11dc5aba6ab72ec40296af9a5c">00275</a>         <span class="keyword">typedef</span> <a class="code" href="classOgre_1_1MapIterator.html" title="Concrete IteratorWrapper for nonconst access to the underlying key-value container.">MapIterator&lt;ResourceManagerMap&gt;</a> <a class="code" href="classOgre_1_1ResourceGroupManager.html#af875db11dc5aba6ab72ec40296af9a5c">ResourceManagerIterator</a>;
<a name="l00277"></a><a class="code" href="structOgre_1_1ResourceGroupManager_1_1ResourceLocation.html">00277</a>         <span class="keyword">struct </span><a class="code" href="structOgre_1_1ResourceGroupManager_1_1ResourceLocation.html" title="Resource location entry.">ResourceLocation</a>
<a name="l00278"></a>00278         {
<a name="l00280"></a><a class="code" href="structOgre_1_1ResourceGroupManager_1_1ResourceLocation.html#a6c67405ce5274cbf9e7ecefc1840539b">00280</a>             <a class="code" href="classOgre_1_1Archive.html" title="Archive-handling class.">Archive</a>* <a class="code" href="structOgre_1_1ResourceGroupManager_1_1ResourceLocation.html#a6c67405ce5274cbf9e7ecefc1840539b" title="Pointer to the archive which is the destination.">archive</a>;
<a name="l00282"></a><a class="code" href="structOgre_1_1ResourceGroupManager_1_1ResourceLocation.html#a89980295496fa459796c2561d0a40f3f">00282</a>             <span class="keywordtype">bool</span> <a class="code" href="structOgre_1_1ResourceGroupManager_1_1ResourceLocation.html#a89980295496fa459796c2561d0a40f3f" title="Whether this location was added recursively.">recursive</a>;
<a name="l00283"></a>00283         };
<a name="l00285"></a><a class="code" href="classOgre_1_1ResourceGroupManager.html#a039c42be59f29534c5883888c969a1c2">00285</a>         <span class="keyword">typedef</span> <a class="code" href="structOgre_1_1list.html">list&lt;ResourceLocation*&gt;::type</a> <a class="code" href="classOgre_1_1ResourceGroupManager.html#a039c42be59f29534c5883888c969a1c2" title="List of possible file locations.">LocationList</a>;
<a name="l00286"></a>00286 
<a name="l00287"></a>00287     <span class="keyword">protected</span>:
<a name="l00289"></a><a class="code" href="classOgre_1_1ResourceGroupManager.html#a82dcce5013ae2f212deed20212d29b59">00289</a>         <a class="code" href="classOgre_1_1ResourceGroupManager.html#af93b96bb29c7d5b2ecc0d37bc82841d4">ResourceManagerMap</a> <a class="code" href="classOgre_1_1ResourceGroupManager.html#a82dcce5013ae2f212deed20212d29b59" title="Map of resource types (strings) to ResourceManagers, used to notify them to load / unload group conte...">mResourceManagerMap</a>;
<a name="l00290"></a>00290 
<a name="l00292"></a><a class="code" href="classOgre_1_1ResourceGroupManager.html#a4a4003b5d0456fa714f4f7ef7d152f58">00292</a>         <span class="keyword">typedef</span> <a class="code" href="structOgre_1_1multimap.html">multimap&lt;Real, ScriptLoader*&gt;::type</a> <a class="code" href="classOgre_1_1ResourceGroupManager.html#a4a4003b5d0456fa714f4f7ef7d152f58" title="Map of loading order (Real) to ScriptLoader, used to order script parsing.">ScriptLoaderOrderMap</a>;
<a name="l00293"></a><a class="code" href="classOgre_1_1ResourceGroupManager.html#a72ebdd393f6b90d5850c4adad6a24b18">00293</a>         <a class="code" href="classOgre_1_1ResourceGroupManager.html#a4a4003b5d0456fa714f4f7ef7d152f58" title="Map of loading order (Real) to ScriptLoader, used to order script parsing.">ScriptLoaderOrderMap</a> <a class="code" href="classOgre_1_1ResourceGroupManager.html#a72ebdd393f6b90d5850c4adad6a24b18">mScriptLoaderOrderMap</a>;
<a name="l00294"></a>00294 
<a name="l00295"></a><a class="code" href="classOgre_1_1ResourceGroupManager.html#ac7a472b6fb477c733cde7e8bbecf4869">00295</a>         <span class="keyword">typedef</span> <a class="code" href="structOgre_1_1vector.html">vector&lt;ResourceGroupListener*&gt;::type</a> <a class="code" href="classOgre_1_1ResourceGroupManager.html#ac7a472b6fb477c733cde7e8bbecf4869">ResourceGroupListenerList</a>;
<a name="l00296"></a><a class="code" href="classOgre_1_1ResourceGroupManager.html#aa661528e26f468563b5ecc15c173a48c">00296</a>         <a class="code" href="classOgre_1_1ResourceGroupManager.html#ac7a472b6fb477c733cde7e8bbecf4869">ResourceGroupListenerList</a> <a class="code" href="classOgre_1_1ResourceGroupManager.html#aa661528e26f468563b5ecc15c173a48c">mResourceGroupListenerList</a>;
<a name="l00297"></a>00297 
<a name="l00298"></a><a class="code" href="classOgre_1_1ResourceGroupManager.html#ae0873f38a86748dc5a59c7bf0eb85075">00298</a>         <a class="code" href="classOgre_1_1ResourceLoadingListener.html">ResourceLoadingListener</a> *<a class="code" href="classOgre_1_1ResourceGroupManager.html#ae0873f38a86748dc5a59c7bf0eb85075">mLoadingListener</a>;
<a name="l00299"></a>00299 
<a name="l00301"></a><a class="code" href="classOgre_1_1ResourceGroupManager.html#ab7bef8c8877dc6bed2c26cbdf7d0b5a1">00301</a>         <span class="keyword">typedef</span> <a class="code" href="structOgre_1_1map.html">map&lt;String, Archive*&gt;::type</a> <a class="code" href="classOgre_1_1ResourceGroupManager.html#ab7bef8c8877dc6bed2c26cbdf7d0b5a1" title="Resource index entry, resourcename-&gt;location.">ResourceLocationIndex</a>;
<a name="l00302"></a>00302 
<a name="l00304"></a><a class="code" href="classOgre_1_1ResourceGroupManager.html#ae78277e18f7f03269812115fd29239e7">00304</a>         <span class="keyword">typedef</span> <a class="code" href="structOgre_1_1list.html">list&lt;ResourcePtr&gt;::type</a> <a class="code" href="classOgre_1_1ResourceGroupManager.html#ae78277e18f7f03269812115fd29239e7" title="List of resources which can be loaded / unloaded.">LoadUnloadResourceList</a>;
<a name="l00306"></a><a class="code" href="structOgre_1_1ResourceGroupManager_1_1ResourceGroup.html">00306</a>         <span class="keyword">struct </span><a class="code" href="structOgre_1_1ResourceGroupManager_1_1ResourceGroup.html" title="Resource group entry.">ResourceGroup</a>
<a name="l00307"></a>00307         {
<a name="l00308"></a><a class="code" href="structOgre_1_1ResourceGroupManager_1_1ResourceGroup.html#a4b15ff98535d242c1bb7912b6007a3a9">00308</a>             <span class="keyword">enum</span> <a class="code" href="structOgre_1_1ResourceGroupManager_1_1ResourceGroup.html#a4b15ff98535d242c1bb7912b6007a3a9">Status</a>
<a name="l00309"></a>00309             {
<a name="l00310"></a><a class="code" href="structOgre_1_1ResourceGroupManager_1_1ResourceGroup.html#a4b15ff98535d242c1bb7912b6007a3a9a832fe1c1854534cc89460a355c1561e8">00310</a>                 UNINITIALSED = 0,
<a name="l00311"></a><a class="code" href="structOgre_1_1ResourceGroupManager_1_1ResourceGroup.html#a4b15ff98535d242c1bb7912b6007a3a9a5fd41aebef904c4603a411714061da11">00311</a>                 INITIALISING = 1,
<a name="l00312"></a><a class="code" href="structOgre_1_1ResourceGroupManager_1_1ResourceGroup.html#a4b15ff98535d242c1bb7912b6007a3a9a1a46cc3cb71014c4a85f4a07e1e41f7a">00312</a>                 INITIALISED = 2,
<a name="l00313"></a><a class="code" href="structOgre_1_1ResourceGroupManager_1_1ResourceGroup.html#a4b15ff98535d242c1bb7912b6007a3a9a855699c308cdd8ccdb67358e4502c658">00313</a>                 LOADING = 3,
<a name="l00314"></a><a class="code" href="structOgre_1_1ResourceGroupManager_1_1ResourceGroup.html#a4b15ff98535d242c1bb7912b6007a3a9a8ec861cc686d84a5ad41433dd856464c">00314</a>                 LOADED = 4
<a name="l00315"></a>00315             };
<a name="l00317"></a>00317             <a class="code" href="OgrePrerequisites_8h.html#a18a523fad1f9e10324e1742865f562b7">OGRE_AUTO_MUTEX</a>
<a name="l00319"></a>00319             <a class="code" href="OgrePrerequisites_8h.html#a2fb96ea8ad9700f804480d1d7f5d692d">OGRE_MUTEX</a>(statusMutex)
<a name="l00321"></a><a class="code" href="structOgre_1_1ResourceGroupManager_1_1ResourceGroup.html#a9c7120b86ff8f19d81f0fac0a1523512">00321</a>             <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> name;
<a name="l00323"></a><a class="code" href="structOgre_1_1ResourceGroupManager_1_1ResourceGroup.html#a3c30f2b5b6146336738c1e50d5bd8734">00323</a>             <a class="code" href="structOgre_1_1ResourceGroupManager_1_1ResourceGroup.html#a4b15ff98535d242c1bb7912b6007a3a9">Status</a> groupStatus;
<a name="l00325"></a><a class="code" href="structOgre_1_1ResourceGroupManager_1_1ResourceGroup.html#a9f040193d573d26cf739005465f4acc7">00325</a>             <a class="code" href="classOgre_1_1ResourceGroupManager.html#a039c42be59f29534c5883888c969a1c2" title="List of possible file locations.">LocationList</a> locationList;
<a name="l00327"></a><a class="code" href="structOgre_1_1ResourceGroupManager_1_1ResourceGroup.html#a8e1f8b2b90535ba8e6a8d81a30888494">00327</a>             <a class="code" href="classOgre_1_1ResourceGroupManager.html#ab7bef8c8877dc6bed2c26cbdf7d0b5a1" title="Resource index entry, resourcename-&gt;location.">ResourceLocationIndex</a> resourceIndexCaseSensitive;
<a name="l00329"></a><a class="code" href="structOgre_1_1ResourceGroupManager_1_1ResourceGroup.html#a40aa3f3b164cf9e1b3bf318dcf3c1283">00329</a>             <a class="code" href="classOgre_1_1ResourceGroupManager.html#ab7bef8c8877dc6bed2c26cbdf7d0b5a1" title="Resource index entry, resourcename-&gt;location.">ResourceLocationIndex</a> resourceIndexCaseInsensitive;
<a name="l00331"></a><a class="code" href="structOgre_1_1ResourceGroupManager_1_1ResourceGroup.html#a130233f52a76fc38ca6fadc4d3182a9c">00331</a>             <a class="code" href="classOgre_1_1ResourceGroupManager.html#a995494b3213135be428eef21990744e5" title="List of resource declarations.">ResourceDeclarationList</a> resourceDeclarations;
<a name="l00333"></a>00333             <span class="comment">// Group by loading order of the type (defined by ResourceManager)</span>
<a name="l00334"></a>00334             <span class="comment">// (e.g. skeletons and materials before meshes)</span>
<a name="l00335"></a><a class="code" href="structOgre_1_1ResourceGroupManager_1_1ResourceGroup.html#a0aa34082b2c1406c9209953c32fa6397">00335</a>             typedef <a class="code" href="structOgre_1_1map.html">map</a>&lt;<a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a>, <a class="code" href="classOgre_1_1ResourceGroupManager.html#ae78277e18f7f03269812115fd29239e7" title="List of resources which can be loaded / unloaded.">LoadUnloadResourceList</a>*&gt;::type <a class="code" href="structOgre_1_1ResourceGroupManager_1_1ResourceGroup.html#a0aa34082b2c1406c9209953c32fa6397" title="Created resources which are ready to be loaded / unloaded.">LoadResourceOrderMap</a>;
<a name="l00336"></a><a class="code" href="structOgre_1_1ResourceGroupManager_1_1ResourceGroup.html#ac63251bf3f946d2b4dc42341b61d4d2a">00336</a>             LoadResourceOrderMap loadResourceOrderMap;
<a name="l00338"></a><a class="code" href="structOgre_1_1ResourceGroupManager_1_1ResourceGroup.html#a63a048530dfded3f7e6189743643578a">00338</a>             <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> worldGeometry;
<a name="l00340"></a><a class="code" href="structOgre_1_1ResourceGroupManager_1_1ResourceGroup.html#a5c0395505e94f137cf4d5bced4054de6">00340</a>             <a class="code" href="classOgre_1_1SceneManager.html" title="Manages the organisation and rendering of a &#39;scene&#39; i.e.">SceneManager</a>* worldGeometrySceneManager;
<a name="l00341"></a>00341             <span class="comment">// in global pool flag - if true the resource will be loaded even a different   group was requested in the load method as a parameter.</span>
<a name="l00342"></a><a class="code" href="structOgre_1_1ResourceGroupManager_1_1ResourceGroup.html#a0619634f1a574be476c2171faeb252cc">00342</a>             <span class="keywordtype">bool</span> inGlobalPool;
<a name="l00343"></a>00343 
<a name="l00344"></a>00344             <span class="keywordtype">void</span> addToIndex(const <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; filename, <a class="code" href="classOgre_1_1Archive.html" title="Archive-handling class.">Archive</a>* arch);
<a name="l00345"></a>00345             <span class="keywordtype">void</span> removeFromIndex(const <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; filename, <a class="code" href="classOgre_1_1Archive.html" title="Archive-handling class.">Archive</a>* arch);
<a name="l00346"></a>00346             <span class="keywordtype">void</span> removeFromIndex(<a class="code" href="classOgre_1_1Archive.html" title="Archive-handling class.">Archive</a>* arch);
<a name="l00347"></a>00347 
<a name="l00348"></a>00348         };
<a name="l00350"></a><a class="code" href="classOgre_1_1ResourceGroupManager.html#abecf110c35bd4d2d26c224773c330ab4">00350</a>         typedef <a class="code" href="structOgre_1_1map.html">map</a>&lt;<a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>, <a class="code" href="structOgre_1_1ResourceGroupManager_1_1ResourceGroup.html" title="Resource group entry.">ResourceGroup</a>*&gt;::type <a class="code" href="classOgre_1_1ResourceGroupManager.html#abecf110c35bd4d2d26c224773c330ab4" title="Map from resource group names to groups.">ResourceGroupMap</a>;
<a name="l00351"></a><a class="code" href="classOgre_1_1ResourceGroupManager.html#ab7f766cbec187cee71d7a5f2cbb5ce89">00351</a>         ResourceGroupMap mResourceGroupMap;
<a name="l00352"></a>00352 
<a name="l00354"></a><a class="code" href="classOgre_1_1ResourceGroupManager.html#adc2312c705ebf3f2cfacdea67b3a8357">00354</a>         String mWorldGroupName;
<a name="l00355"></a>00355 
<a name="l00361"></a>00361         <span class="keywordtype">void</span> parseResourceGroupScripts(<a class="code" href="structOgre_1_1ResourceGroupManager_1_1ResourceGroup.html" title="Resource group entry.">ResourceGroup</a>* grp);
<a name="l00366"></a>00366         <span class="keywordtype">void</span> createDeclaredResources(<a class="code" href="structOgre_1_1ResourceGroupManager_1_1ResourceGroup.html" title="Resource group entry.">ResourceGroup</a>* grp);
<a name="l00368"></a>00368         <span class="keywordtype">void</span> addCreatedResource(<a class="code" href="classOgre_1_1SharedPtr.html">ResourcePtr</a>&amp; res, <a class="code" href="structOgre_1_1ResourceGroupManager_1_1ResourceGroup.html" title="Resource group entry.">ResourceGroup</a>&amp; group);
<a name="l00370"></a>00370         <a class="code" href="structOgre_1_1ResourceGroupManager_1_1ResourceGroup.html" title="Resource group entry.">ResourceGroup</a>* getResourceGroup(const String&amp; name);
<a name="l00372"></a>00372         <span class="keywordtype">void</span> dropGroupContents(<a class="code" href="structOgre_1_1ResourceGroupManager_1_1ResourceGroup.html" title="Resource group entry.">ResourceGroup</a>* grp);
<a name="l00374"></a>00374         <span class="keywordtype">void</span> deleteGroup(<a class="code" href="structOgre_1_1ResourceGroupManager_1_1ResourceGroup.html" title="Resource group entry.">ResourceGroup</a>* grp);
<a name="l00376"></a>00376         <a class="code" href="structOgre_1_1ResourceGroupManager_1_1ResourceGroup.html" title="Resource group entry.">ResourceGroup</a>* findGroupContainingResourceImpl(const String&amp; filename);
<a name="l00378"></a>00378         <span class="keywordtype">void</span> fireResourceGroupScriptingStarted(const String&amp; groupName, <span class="keywordtype">size_t</span> scriptCount);
<a name="l00380"></a>00380         <span class="keywordtype">void</span> fireScriptStarted(const String&amp; scriptName, <span class="keywordtype">bool</span> &amp;skipScript);
<a name="l00382"></a>00382         <span class="keywordtype">void</span> fireScriptEnded(const String&amp; scriptName, <span class="keywordtype">bool</span> skipped);
<a name="l00384"></a>00384         <span class="keywordtype">void</span> fireResourceGroupScriptingEnded(const String&amp; groupName);
<a name="l00386"></a>00386         <span class="keywordtype">void</span> fireResourceGroupLoadStarted(const String&amp; groupName, <span class="keywordtype">size_t</span> resourceCount);
<a name="l00388"></a>00388         <span class="keywordtype">void</span> fireResourceLoadStarted(const <a class="code" href="classOgre_1_1SharedPtr.html">ResourcePtr</a>&amp; resource);
<a name="l00390"></a>00390         <span class="keywordtype">void</span> fireResourceLoadEnded(<span class="keywordtype">void</span>);
<a name="l00392"></a>00392         <span class="keywordtype">void</span> fireResourceGroupLoadEnded(const String&amp; groupName);
<a name="l00394"></a>00394         <span class="keywordtype">void</span> fireResourceGroupPrepareStarted(const String&amp; groupName, <span class="keywordtype">size_t</span> resourceCount);
<a name="l00396"></a>00396         <span class="keywordtype">void</span> fireResourcePrepareStarted(const <a class="code" href="classOgre_1_1SharedPtr.html">ResourcePtr</a>&amp; resource);
<a name="l00398"></a>00398         <span class="keywordtype">void</span> fireResourcePrepareEnded(<span class="keywordtype">void</span>);
<a name="l00400"></a>00400         <span class="keywordtype">void</span> fireResourceGroupPrepareEnded(const String&amp; groupName);
<a name="l00401"></a>00401 
<a name="l00403"></a><a class="code" href="classOgre_1_1ResourceGroupManager.html#ab40aa8555ffed48c406fc9249cced867">00403</a>         <a class="code" href="structOgre_1_1ResourceGroupManager_1_1ResourceGroup.html" title="Resource group entry.">ResourceGroup</a>* mCurrentGroup;
<a name="l00404"></a>00404     public:
<a name="l00405"></a>00405         <a class="code" href="classOgre_1_1ResourceGroupManager.html" title="This singleton class manages the list of resource groups, and notifying the various resource managers...">ResourceGroupManager</a>();
<a name="l00406"></a>00406         virtual ~ResourceGroupManager();
<a name="l00407"></a>00407 
<a name="l00445"></a>00445         <span class="keywordtype">void</span> createResourceGroup(const String&amp; name, const <span class="keywordtype">bool</span> inGlobalPool = true);
<a name="l00446"></a>00446 
<a name="l00447"></a>00447 
<a name="l00487"></a>00487         <span class="keywordtype">void</span> initialiseResourceGroup(const String&amp; name);
<a name="l00488"></a>00488 
<a name="l00492"></a>00492         <span class="keywordtype">void</span> initialiseAllResourceGroups(<span class="keywordtype">void</span>);
<a name="l00493"></a>00493 
<a name="l00511"></a>00511         <span class="keywordtype">void</span> prepareResourceGroup(const String&amp; name, <span class="keywordtype">bool</span> prepareMainResources = true, 
<a name="l00512"></a>00512             <span class="keywordtype">bool</span> prepareWorldGeom = true);
<a name="l00513"></a>00513 
<a name="l00531"></a>00531         <span class="keywordtype">void</span> loadResourceGroup(const String&amp; name, <span class="keywordtype">bool</span> loadMainResources = true, 
<a name="l00532"></a>00532             <span class="keywordtype">bool</span> loadWorldGeom = true);
<a name="l00533"></a>00533 
<a name="l00549"></a>00549         <span class="keywordtype">void</span> unloadResourceGroup(const String&amp; name, <span class="keywordtype">bool</span> reloadableOnly = true);
<a name="l00550"></a>00550 
<a name="l00562"></a>00562         <span class="keywordtype">void</span> unloadUnreferencedResourcesInGroup(const String&amp; name, 
<a name="l00563"></a>00563             <span class="keywordtype">bool</span> reloadableOnly = true);
<a name="l00564"></a>00564 
<a name="l00574"></a>00574         <span class="keywordtype">void</span> clearResourceGroup(const String&amp; name);
<a name="l00575"></a>00575         
<a name="l00581"></a>00581         <span class="keywordtype">void</span> destroyResourceGroup(const String&amp; name);
<a name="l00582"></a>00582 
<a name="l00590"></a>00590         <span class="keywordtype">bool</span> isResourceGroupInitialised(const String&amp; name);
<a name="l00591"></a>00591 
<a name="l00599"></a>00599         <span class="keywordtype">bool</span> isResourceGroupLoaded(const String&amp; name);
<a name="l00600"></a>00600 
<a name="l00601"></a>00601         <span class="comment">/*** Verify if a resource group exists</span>
<a name="l00602"></a>00602 <span class="comment">        @param name The name of the resource group to look for</span>
<a name="l00603"></a>00603 <span class="comment">        */</span>
<a name="l00604"></a>00604         <span class="keywordtype">bool</span> resourceGroupExists(const String&amp; name);
<a name="l00605"></a>00605 
<a name="l00627"></a>00627         <span class="keywordtype">void</span> addResourceLocation(const String&amp; name, const String&amp; locType, 
<a name="l00628"></a>00628             const String&amp; resGroup = DEFAULT_RESOURCE_GROUP_NAME, <span class="keywordtype">bool</span> recursive = false);
<a name="l00630"></a>00630         <span class="keywordtype">void</span> removeResourceLocation(const String&amp; name, 
<a name="l00631"></a>00631             const String&amp; resGroup = DEFAULT_RESOURCE_GROUP_NAME);
<a name="l00633"></a>00633         <span class="keywordtype">bool</span> resourceLocationExists(const String&amp; name, 
<a name="l00634"></a>00634             const String&amp; resGroup = DEFAULT_RESOURCE_GROUP_NAME);
<a name="l00635"></a>00635 
<a name="l00670"></a>00670         <span class="keywordtype">void</span> declareResource(const String&amp; name, const String&amp; resourceType,
<a name="l00671"></a>00671             const String&amp; groupName = DEFAULT_RESOURCE_GROUP_NAME,
<a name="l00672"></a>00672             const <a class="code" href="group__General.html#gadccb207c184efc0a6fb2a00ab6320d19" title="Name / value parameter pair (first = name, second = value)">NameValuePairList</a>&amp; loadParameters = <a class="code" href="group__General.html#gadccb207c184efc0a6fb2a00ab6320d19" title="Name / value parameter pair (first = name, second = value)">NameValuePairList</a>());
<a name="l00712"></a>00712         <span class="keywordtype">void</span> declareResource(const String&amp; name, const String&amp; resourceType,
<a name="l00713"></a>00713             const String&amp; groupName, <a class="code" href="classOgre_1_1ManualResourceLoader.html" title="Interface describing a manual resource loader.">ManualResourceLoader</a>* loader,
<a name="l00714"></a>00714             const NameValuePairList&amp; loadParameters = NameValuePairList());
<a name="l00725"></a>00725         <span class="keywordtype">void</span> undeclareResource(const String&amp; name, const String&amp; groupName);
<a name="l00726"></a>00726 
<a name="l00746"></a>00746         <a class="code" href="classOgre_1_1SharedPtr.html">DataStreamPtr</a> openResource(const String&amp; resourceName, 
<a name="l00747"></a>00747             const String&amp; groupName = DEFAULT_RESOURCE_GROUP_NAME,
<a name="l00748"></a>00748             <span class="keywordtype">bool</span> searchGroupsIfNotFound = true, <a class="code" href="classOgre_1_1Resource.html" title="Abstract class representing a loadable resource (e.g.">Resource</a>* resourceBeingLoaded = 0);
<a name="l00749"></a>00749 
<a name="l00761"></a>00761         <a class="code" href="classOgre_1_1SharedPtr.html" title="Reference-counted shared pointer, used for objects where implicit destruction is required.">DataStreamListPtr</a> openResources(const String&amp; pattern, 
<a name="l00762"></a>00762             const String&amp; groupName = DEFAULT_RESOURCE_GROUP_NAME);
<a name="l00763"></a>00763         
<a name="l00772"></a>00772         <a class="code" href="classOgre_1_1SharedPtr.html" title="Reference-counted shared pointer, used for objects where implicit destruction is required.">StringVectorPtr</a> listResourceNames(const String&amp; groupName, <span class="keywordtype">bool</span> dirs = false);
<a name="l00773"></a>00773 
<a name="l00780"></a>00780         <a class="code" href="classOgre_1_1SharedPtr.html" title="Reference-counted shared pointer, used for objects where implicit destruction is required.">FileInfoListPtr</a> listResourceFileInfo(const String&amp; groupName, <span class="keywordtype">bool</span> dirs = false);
<a name="l00781"></a>00781 
<a name="l00793"></a>00793         <a class="code" href="classOgre_1_1SharedPtr.html" title="Reference-counted shared pointer, used for objects where implicit destruction is required.">StringVectorPtr</a> findResourceNames(const String&amp; groupName, const String&amp; pattern,
<a name="l00794"></a>00794             <span class="keywordtype">bool</span> dirs = false);
<a name="l00795"></a>00795 
<a name="l00800"></a>00800         <span class="keywordtype">bool</span> resourceExists(const String&amp; group, const String&amp; filename);
<a name="l00801"></a>00801 
<a name="l00806"></a>00806         <span class="keywordtype">bool</span> resourceExists(<a class="code" href="structOgre_1_1ResourceGroupManager_1_1ResourceGroup.html" title="Resource group entry.">ResourceGroup</a>* group, const String&amp; filename);
<a name="l00807"></a>00807         
<a name="l00811"></a>00811         <span class="keywordtype">bool</span> resourceExistsInAnyGroup(const String&amp; filename);
<a name="l00812"></a>00812 
<a name="l00819"></a>00819         const String&amp; findGroupContainingResource(const String&amp; filename);
<a name="l00820"></a>00820 
<a name="l00830"></a>00830         <a class="code" href="classOgre_1_1SharedPtr.html" title="Reference-counted shared pointer, used for objects where implicit destruction is required.">FileInfoListPtr</a> findResourceFileInfo(const String&amp; group, const String&amp; pattern,
<a name="l00831"></a>00831             <span class="keywordtype">bool</span> dirs = false);
<a name="l00832"></a>00832 
<a name="l00834"></a>00834         time_t resourceModifiedTime(const String&amp; group, const String&amp; filename); 
<a name="l00839"></a>00839         <a class="code" href="classOgre_1_1SharedPtr.html" title="Reference-counted shared pointer, used for objects where implicit destruction is required.">StringVectorPtr</a> listResourceLocations(const String&amp; groupName);
<a name="l00840"></a>00840 
<a name="l00847"></a>00847         <a class="code" href="classOgre_1_1SharedPtr.html" title="Reference-counted shared pointer, used for objects where implicit destruction is required.">StringVectorPtr</a> findResourceLocation(const String&amp; groupName, const String&amp; pattern);
<a name="l00848"></a>00848 
<a name="l00850"></a>00850         time_t resourceModifiedTime(<a class="code" href="structOgre_1_1ResourceGroupManager_1_1ResourceGroup.html" title="Resource group entry.">ResourceGroup</a>* group, const String&amp; filename); 
<a name="l00851"></a>00851 
<a name="l00866"></a>00866         <a class="code" href="classOgre_1_1SharedPtr.html">DataStreamPtr</a> createResource(const String&amp; filename, const String&amp; groupName = DEFAULT_RESOURCE_GROUP_NAME, 
<a name="l00867"></a>00867             <span class="keywordtype">bool</span> overwrite = false, const String&amp; locationPattern = <a class="code" href="classOgre_1_1StringUtil.html" title="Utility class for manipulating Strings.">StringUtil</a>::BLANK);
<a name="l00868"></a>00868 
<a name="l00878"></a>00878         <span class="keywordtype">void</span> deleteResource(const String&amp; filename, const String&amp; groupName = DEFAULT_RESOURCE_GROUP_NAME, 
<a name="l00879"></a>00879             const String&amp; locationPattern = <a class="code" href="classOgre_1_1StringUtil.html" title="Utility class for manipulating Strings.">StringUtil</a>::BLANK);
<a name="l00880"></a>00880 
<a name="l00890"></a>00890         <span class="keywordtype">void</span> deleteMatchingResources(const String&amp; filePattern, const String&amp; groupName = DEFAULT_RESOURCE_GROUP_NAME, 
<a name="l00891"></a>00891             const String&amp; locationPattern = <a class="code" href="classOgre_1_1StringUtil.html" title="Utility class for manipulating Strings.">StringUtil</a>::BLANK);
<a name="l00892"></a>00892 
<a name="l00896"></a>00896         <span class="keywordtype">void</span> addResourceGroupListener(<a class="code" href="classOgre_1_1ResourceGroupListener.html" title="This abstract class defines an interface which is called back during resource group loading to indica...">ResourceGroupListener</a>* l);
<a name="l00898"></a>00898         <span class="keywordtype">void</span> removeResourceGroupListener(<a class="code" href="classOgre_1_1ResourceGroupListener.html" title="This abstract class defines an interface which is called back during resource group loading to indica...">ResourceGroupListener</a>* l);
<a name="l00899"></a>00899 
<a name="l00906"></a><a class="code" href="classOgre_1_1ResourceGroupManager.html#a407415b99c1df3b275e2609e16e8b39f">00906</a>         <span class="keywordtype">void</span> setWorldResourceGroupName(const String&amp; groupName) {mWorldGroupName = groupName;}
<a name="l00907"></a>00907 
<a name="l00909"></a><a class="code" href="classOgre_1_1ResourceGroupManager.html#a6a5134c3cf869331c5740a6a5e2728f0">00909</a>         <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; <a class="code" href="classOgre_1_1ResourceGroupManager.html#a6a5134c3cf869331c5740a6a5e2728f0" title="Gets the resource group that &#39;world&#39; resources will use.">getWorldResourceGroupName</a>(<span class="keywordtype">void</span>)<span class="keyword"> const </span>{ <span class="keywordflow">return</span> mWorldGroupName; }
<a name="l00910"></a>00910 
<a name="l00924"></a>00924         <span class="keywordtype">void</span> linkWorldGeometryToResourceGroup(<span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; group, 
<a name="l00925"></a>00925             <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; worldGeometry, <a class="code" href="classOgre_1_1SceneManager.html" title="Manages the organisation and rendering of a &#39;scene&#39; i.e.">SceneManager</a>* sceneManager);
<a name="l00926"></a>00926 
<a name="l00931"></a>00931         <span class="keywordtype">void</span> unlinkWorldGeometryFromResourceGroup(<span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; group);
<a name="l00932"></a>00932 
<a name="l00940"></a>00940         <span class="keywordtype">bool</span> isResourceGroupInGlobalPool(<span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; name);
<a name="l00941"></a>00941 
<a name="l00943"></a>00943         <span class="keywordtype">void</span> shutdownAll(<span class="keywordtype">void</span>);
<a name="l00944"></a>00944 
<a name="l00945"></a>00945 
<a name="l00955"></a>00955         <span class="keywordtype">void</span> _registerResourceManager(<span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; resourceType, <a class="code" href="classOgre_1_1ResourceManager.html" title="Defines a generic resource handler.">ResourceManager</a>* rm);
<a name="l00956"></a>00956 
<a name="l00963"></a>00963         <span class="keywordtype">void</span> _unregisterResourceManager(<span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; resourceType);
<a name="l00964"></a>00964 
<a name="l00967"></a><a class="code" href="classOgre_1_1ResourceGroupManager.html#a7e64ea1228280465675f0b1438d21e4a">00967</a>         <a class="code" href="classOgre_1_1MapIterator.html" title="Concrete IteratorWrapper for nonconst access to the underlying key-value container.">ResourceManagerIterator</a> getResourceManagerIterator()
<a name="l00968"></a>00968         { <span class="keywordflow">return</span> <a class="code" href="classOgre_1_1MapIterator.html" title="Concrete IteratorWrapper for nonconst access to the underlying key-value container.">ResourceManagerIterator</a>(
<a name="l00969"></a>00969             mResourceManagerMap.begin(), mResourceManagerMap.end()); }
<a name="l00970"></a>00970 
<a name="l00975"></a>00975         <span class="keywordtype">void</span> _registerScriptLoader(<a class="code" href="classOgre_1_1ScriptLoader.html" title="Abstract class defining the interface used by classes which wish to perform script loading to define ...">ScriptLoader</a>* su);
<a name="l00976"></a>00976 
<a name="l00980"></a>00980         <span class="keywordtype">void</span> _unregisterScriptLoader(<a class="code" href="classOgre_1_1ScriptLoader.html" title="Abstract class defining the interface used by classes which wish to perform script loading to define ...">ScriptLoader</a>* su);
<a name="l00981"></a>00981 
<a name="l00985"></a>00985         <a class="code" href="classOgre_1_1ScriptLoader.html" title="Abstract class defining the interface used by classes which wish to perform script loading to define ...">ScriptLoader</a> *_findScriptLoader(<span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> &amp;pattern);
<a name="l00986"></a>00986 
<a name="l00990"></a>00990         <a class="code" href="classOgre_1_1ResourceManager.html" title="Defines a generic resource handler.">ResourceManager</a>* _getResourceManager(<span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; resourceType);
<a name="l00991"></a>00991 
<a name="l00995"></a>00995         <span class="keywordtype">void</span> _notifyResourceCreated(<a class="code" href="classOgre_1_1SharedPtr.html">ResourcePtr</a>&amp; res);
<a name="l00996"></a>00996 
<a name="l01000"></a>01000         <span class="keywordtype">void</span> _notifyResourceRemoved(<a class="code" href="classOgre_1_1SharedPtr.html">ResourcePtr</a>&amp; res);
<a name="l01001"></a>01001 
<a name="l01004"></a>01004         <span class="keywordtype">void</span> _notifyResourceGroupChanged(<span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; oldGroup, <a class="code" href="classOgre_1_1Resource.html" title="Abstract class representing a loadable resource (e.g.">Resource</a>* res);
<a name="l01005"></a>01005 
<a name="l01010"></a>01010         <span class="keywordtype">void</span> _notifyAllResourcesRemoved(<a class="code" href="classOgre_1_1ResourceManager.html" title="Defines a generic resource handler.">ResourceManager</a>* manager);
<a name="l01011"></a>01011 
<a name="l01019"></a>01019         <span class="keywordtype">void</span> _notifyWorldGeometryStageStarted(<span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; description);
<a name="l01027"></a>01027         <span class="keywordtype">void</span> _notifyWorldGeometryStageEnded(<span class="keywordtype">void</span>);
<a name="l01028"></a>01028 
<a name="l01034"></a>01034         <a class="code" href="group__General.html#ga0899c03496d3c25c6555889aa76a78db">StringVector</a> getResourceGroups(<span class="keywordtype">void</span>);
<a name="l01041"></a>01041         ResourceDeclarationList getResourceDeclarationList(<span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; groupName);
<a name="l01042"></a>01042 
<a name="l01047"></a>01047         <span class="keyword">const</span> LocationList&amp; getResourceLocationList(<span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; groupName);
<a name="l01048"></a>01048 
<a name="l01050"></a>01050         <span class="keywordtype">void</span> setLoadingListener(<a class="code" href="classOgre_1_1ResourceLoadingListener.html">ResourceLoadingListener</a> *listener);
<a name="l01052"></a>01052         <a class="code" href="classOgre_1_1ResourceLoadingListener.html">ResourceLoadingListener</a> *getLoadingListener();
<a name="l01053"></a>01053 
<a name="l01069"></a>01069         <span class="keyword">static</span> <a class="code" href="classOgre_1_1ResourceGroupManager.html" title="This singleton class manages the list of resource groups, and notifying the various resource managers...">ResourceGroupManager</a>&amp; getSingleton(<span class="keywordtype">void</span>);
<a name="l01085"></a>01085         <span class="keyword">static</span> <a class="code" href="classOgre_1_1ResourceGroupManager.html" title="This singleton class manages the list of resource groups, and notifying the various resource managers...">ResourceGroupManager</a>* getSingletonPtr(<span class="keywordtype">void</span>);
<a name="l01086"></a>01086 
<a name="l01087"></a>01087     };
<a name="l01090"></a>01090 }
<a name="l01091"></a>01091 
<a name="l01092"></a>01092 <span class="preprocessor">#endif</span>
</pre></div></div><!-- contents -->
<hr>
<p>
Copyright &copy; 2012 Torus Knot Software Ltd<br />
<!--Creative Commons License--><a rel="license" href="http://creativecommons.org/licenses/by-sa/3.0/"><img alt="Creative Commons License" style="border-width:0" src="http://i.creativecommons.org/l/by-sa/3.0/88x31.png" /></a><br />This work is licensed under a <a rel="license" href="http://creativecommons.org/licenses/by-sa/3.0/">Creative Commons Attribution-ShareAlike 3.0 Unported License</a>.<br/>
		<!--/Creative Commons License--><!-- <rdf:RDF xmlns="http://web.resource.org/cc/" xmlns:dc="http://purl.org/dc/elements/1.1/" xmlns:rdf="http://www.w3.org/1999/02/22-rdf-syntax-ns#">
		<Work rdf:about="">
			<license rdf:resource="http://creativecommons.org/licenses/by-sa/2.5/" />
	<dc:type rdf:resource="http://purl.org/dc/dcmitype/Text" />
		</Work>
		<License rdf:about="http://creativecommons.org/licenses/by-sa/2.5/"><permits rdf:resource="http://web.resource.org/cc/Reproduction"/><permits rdf:resource="http://web.resource.org/cc/Distribution"/><requires rdf:resource="http://web.resource.org/cc/Notice"/><requires rdf:resource="http://web.resource.org/cc/Attribution"/><permits rdf:resource="http://web.resource.org/cc/DerivativeWorks"/><requires rdf:resource="http://web.resource.org/cc/ShareAlike"/></License></rdf:RDF> -->

Last modified Fri May 25 2012 21:48:51
</p>
</body>
</html>
